package ru.dbotthepony.mc.otm.client.screen

import net.minecraft.network.chat.Component
import net.minecraft.world.entity.player.Inventory
import ru.dbotthepony.mc.otm.client.screen.panels.BatterySlotPanel
import ru.dbotthepony.mc.otm.client.screen.panels.FramePanel
import ru.dbotthepony.mc.otm.client.screen.panels.SlotPanel
import ru.dbotthepony.mc.otm.client.screen.widget.PowerGaugePanel
import ru.dbotthepony.mc.otm.client.screen.widget.ProgressGaugePanel
import ru.dbotthepony.mc.otm.client.screen.widget.WidePowerGaugePanel
import ru.dbotthepony.mc.otm.menu.PlatePressMenu

class PlatePressScreen(menu: PlatePressMenu, inventory: Inventory, title: Component) :
	MatteryScreen<PlatePressMenu>(menu, inventory, title) {
	override fun makeMainFrame(): FramePanel<out MatteryScreen<*>> {
		val frame = super.makeMainFrame()!!

		WidePowerGaugePanel(this, frame, menu.powerWidget, LEFT_MARGIN, GAUGE_TOP_WITH_SLOT)
		BatterySlotPanel(this, frame, menu.batterySlot, LEFT_MARGIN, SLOT_TOP_UNDER_GAUGE)

		SlotPanel(this, frame, menu.inputSlot, 56f, PROGRESS_SLOT_TOP)
		ProgressGaugePanel(this, frame, menu.progressGauge, 78f, PROGRESS_ARROW_TOP)
		SlotPanel(this, frame, menu.outputSlot, 104f, PROGRESS_SLOT_TOP)

		return frame
	}
}
